# remirepo/Fedora spec file for php-zendframework-zend-xml2json
#
# Copyright (c) 2016-2018 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global bootstrap    0
%global gh_commit    1fd6e09dfc3e9de5e873afc4fcadd541a15a4572
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     zendframework
%global gh_project   zend-xml2json
%global php_home     %{_datadir}/php
%global library      Xml2Json
%if %{bootstrap}
%global with_tests   0%{?_with_tests:1}
%else
%global with_tests   0%{!?_without_tests:1}
%endif

Name:           php-%{gh_owner}-%{gh_project}
Version:        3.1.1
Release:        1%{?dist}
Summary:        Provides functionality for converting XML to JSON

Group:          Development/Libraries
License:        BSD
URL:            https://zendframework.github.io/%{gh_project}/
Source0:        %{gh_commit}/%{name}-%{version}-%{gh_short}.tgz
Source1:        makesrc.sh

BuildArch:      noarch
# Tests
%if %{with_tests}
BuildRequires:  php(language) >= 5.6
BuildRequires:  php-pcre
BuildRequires:  php-spl
# From composer, "require-dev": {
#        "phpunit/phpunit": "^5.7.27 || ^6.5.8 || ^7.1.4",
#        "zendframework/zend-coding-standard": "~1.0.0"
# remirepo:1
%if 0%{?fedora} >= 27 || 0%{?rhel} >= 8
BuildRequires: (php-autoloader(%{gh_owner}/zend-json)           >= 2.6.1 with php-autoloader(%{gh_owner}/zend-json)           < 4)
BuildRequires: (php-autoloader(%{gh_owner}/zendxml)             >= 1.0.2 with php-autoloader(%{gh_owner}/zendxml)             < 2)
%global phpunit %{_bindir}/phpunit7
BuildRequires:  phpunit7 >= 7.1.4
# remirepo:8
%else
BuildRequires:  php-autoloader(%{gh_owner}/zend-json)           <  4
BuildRequires:  php-autoloader(%{gh_owner}/zend-json)           >= 2.6.1
BuildRequires:  php-autoloader(%{gh_owner}/zendxml)             <  2
BuildRequires:  php-autoloader(%{gh_owner}/zendxml)             >= 1.0.2
%global phpunit %{_bindir}/phpunit6
BuildRequires:  phpunit6 >= 6.5.8
%endif
%endif
# Autoloader
BuildRequires:  php-fedora-autoloader-devel

# From composer, "require": {
#        "php": "^5.6 || ^7.0",
#        "zendframework/zend-json": "^2.6.1 || ^3.0",
#        "zendframework/zendxml": "^1.0.2"
Requires:       php(language) >= 5.6
%if ! %{bootstrap}
# remirepo:1
%if 0%{?fedora} >= 27 || 0%{?rhel} >= 8
Requires:      (php-autoloader(%{gh_owner}/zend-json)           >= 2.6.1 with php-autoloader(%{gh_owner}/zend-json)           < 4)
Requires:      (php-autoloader(%{gh_owner}/zendxml)             >= 1.0.2 with php-autoloader(%{gh_owner}/zendxml)             < 2)
# remirepo:6
%else
Requires:       php-autoloader(%{gh_owner}/zend-json)           >= 2.6.1
Requires:       php-autoloader(%{gh_owner}/zend-json)           <  4
Requires:       php-autoloader(%{gh_owner}/zendxml)             >= 1.0.2
Requires:       php-autoloader(%{gh_owner}/zendxml)             <  2
%endif
%endif
# Autoloader
Requires:       php-composer(fedora/autoloader)
# From phpcompatinfo report for version 3.0.0
Requires:       php-pcre
Requires:       php-spl

Provides:       php-composer(%{gh_owner}/%{gh_project}) = %{version}
Provides:       php-autoloader(%{gh_owner}/%{gh_project}) = %{version}


%description
zend-xml2json provides functionality for converting XML structures to JSON.

* File issues at https://github.com/zendframework/zend-xml2json/issues
* Documentation is at https://zendframework.github.io/zend-xml2json/


%prep
%setup -q -n %{gh_project}-%{gh_commit}

mv LICENSE.md LICENSE


%build
: Create autoloader
phpab --template fedora --output src/autoload.php src
cat << 'EOF' | tee -a src/autoload.php
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/Zend/Json/autoload.php',
    '%{php_home}/ZendXml/autoload.php',
]);
EOF


%install
mkdir -p   %{buildroot}%{php_home}/Zend/
cp -pr src %{buildroot}%{php_home}/Zend/%{library}


%check
%if %{with_tests}
mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
require_once '%{buildroot}%{php_home}/Zend/%{library}/autoload.php';
\Fedora\Autoloader\Autoload::addPsr4('ZendTest\\%{library}\\', dirname(__DIR__) . '/test');
EOF

ret=0
for cmdarg in "php %{phpunit}" "php56 %{_bindir}/phpunit" "php70 %{_bindir}/phpunit6" php71 php72; do
  if which $cmdarg; then
    set $cmdarg
    $1 ${2:-%{_bindir}/phpunit7} --verbose || ret=1
  fi
done
exit $ret
%else
: Test suite disabled
%endif


%files
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc *.md
%doc composer.json
%{php_home}/Zend/%{library}


%changelog
* Wed May  2 2018 Remi Collet <remi@remirepo.net> - 3.1.1-1
- update to 3.1.1
- use range dependencies
- switch to phpunit7

* Wed Dec  6 2017 Remi Collet <remi@remirepo.net> - 3.1.0-2
- switch from zend-loader to fedora/autoloader

* Tue Oct 17 2017 Remi Collet <remi@remirepo.net> - 3.1.0-1
- Update to 3.1.0
- raise dependency on PHP 5.6
- use phpunit6 on F26+

* Wed Jun 29 2016 Remi Collet <remi@fedoraproject.org> - 3.0.0-1
- initial package

